package com.bwie.auth.controller;

import com.bwie.auth.service.AuthService;
import com.bwie.common.domain.request.UserReq;
import com.bwie.common.domain.response.JwtResp;
import com.bwie.common.domain.response.UserResp;
import com.bwie.common.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.scheduling.annotation.Schedules;
import org.springframework.web.bind.annotation.*;

/**
 * @Author：weiran
 * @Package：com.bwie.auth.controller
 * @Project：week3
 * @name：AuthController
 * @Date：2024/8/6 9:51
 */
@RequestMapping("/auth")
@RestController
public class AuthController {

    @Autowired
    private AuthService authService;

    /**
     * 发送验证码
     * @param
     * @return
     */
    @PostMapping("/sendcode/{userPhone}")
    public Result sendcode(@PathVariable String userPhone){
        return Result.success(authService.sendcode(userPhone));
    }


    /**
     * 登录
     * @return
     */
    @PostMapping("/login")
    public Result<JwtResp>login(@RequestBody UserReq userReq){
        return Result.success(authService.login(userReq));
    }


    /**
     * 身份验证
     * @return
     */
    @GetMapping("/info")
    public Result<UserResp> getInfo(){
        return Result.success(authService.getInfo());
    }
}
