package com.bwie.auth.feign;

import com.bwie.auth.feign.factory.AuthFeignFactory;
import com.bwie.common.domain.response.UserResp;
import com.bwie.common.result.Result;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;

/**
 * @Author：weiran
 * @Package：com.bwie.auth.feign
 * @Project：week3
 * @name：AuthFeign
 * @Date：2024/8/6 9:52
 */
@FeignClient(value = "bwie-user",fallbackFactory = AuthFeignFactory.class)
public interface AuthFeign {

    @PostMapping("/user/user/findByuserPhone/{userPhone}")
    Result<UserResp> findByuserPhone(@PathVariable String userPhone);
}
