package com.bwie.auth.feign.factory;

import com.bwie.auth.feign.AuthFeign;
import com.bwie.common.domain.response.UserResp;
import com.bwie.common.result.Result;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;

/**
 * @Author：weiran
 * @Package：com.bwie.auth.feign.factory
 * @Project：week3
 * @name：AuthFeignFactory
 * @Date：2024/8/6 10:01
 */
@Component
public class AuthFeignFactory implements FallbackFactory<AuthFeign> {
    @Override
    public AuthFeign create(Throwable cause) {
        return new AuthFeign() {
            @Override
            public Result<UserResp> findByuserPhone(String userPhone) {
                return Result.error("操作异常，已进入熔断状态");
            }
        };
    }
}
