package com.bwie.common.controlleradvice;

import com.bwie.common.exception.ProductException;
import com.bwie.common.result.Result;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;

/**
 * @Author：weiran
 * @Package：com.bwie.common.controlleradvice
 * @Project：week3
 * @name：ProductControllerAdvice
 * @Date：2024/8/6 9:54
 */
@RestControllerAdvice
@Slf4j
public class ProductControllerAdvice {


    @ExceptionHandler(value = ProductException.class)
    public Result productHandler(Throwable e){
        StackTraceElement stackTraceElement = e.getStackTrace()[0];
        String className = stackTraceElement.getClassName();
        String fileName = stackTraceElement.getFileName();
        int lineNumber = stackTraceElement.getLineNumber();
        String methodName = stackTraceElement.getMethodName();
        return Result.error(e.getMessage(),"此处报错在：类名：{"+className+"}," +
                "类文件名：{"+fileName+"},行数：{"+lineNumber+"},方法名：{"+methodName+"}");

    }

}
