//package com.bwie.gateway.filters;
//
//import com.bwie.common.constants.TokenConstants;
//import com.bwie.common.utils.JwtUtils;
//import com.bwie.common.utils.StringUtils;
//import com.bwie.gateway.config.IgnoreWhiteConfig;
//import com.bwie.gateway.utils.GatewayUtils;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.cloud.gateway.filter.GatewayFilterChain;
//import org.springframework.cloud.gateway.filter.GlobalFilter;
//import org.springframework.core.*;
//import org.springframework.data.redis.core.StringRedisTemplate;
//import org.springframework.http.server.reactive.ServerHttpRequest;
//import org.springframework.stereotype.Component;
//import org.springframework.web.server.ServerWebExchange;
//import reactor.core.publisher.Mono;
//
//import java.util.List;
//import java.util.concurrent.TimeUnit;
//
//@Component
//public class AuthFilter implements GlobalFilter, Ordered {
//
//    @Autowired
//    private IgnoreWhiteConfig ignoreWhiteConfig;
//
//    @Autowired
//    private StringRedisTemplate redisTemplate;
//
//    /**
//     * 过滤方法
//     * @name:weiran
//     * @param exchange  请求的上下文 通过这个对象获取 请求对象和相应对象
//     * @param chain     网关过滤器链  放行
//     * @return
//     */
//    @Override
//    public Mono<Void> filter(ServerWebExchange exchange, GatewayFilterChain chain) {
//        //  验证请求是否是白名单请求
//        // 加载系统白名单请求
//        List<String> whites = ignoreWhiteConfig.getWhites();
//        // 判断当前请求的 URI 是否是白名单
//        ServerHttpRequest request = exchange.getRequest();
//        String path = request.getURI().getPath();
//        if (StringUtils.matches(path, whites)) {
//            // 是白名单请求直接放行
//            return chain.filter(exchange);
//        }
//        // 验证 token 获取 token
//        String token = request.getHeaders().getFirst(TokenConstants.TOKEN);
//        // 非空验证
//        if (StringUtils.isBlank(token)) {
//            return GatewayUtils.errorResponse(exchange, "无权访问");
//        }
//        // 合法性验证
//        try {
//            JwtUtils.parseToken(token);
//        } catch (Exception ex) {
//            return GatewayUtils.errorResponse(exchange, "token不合法");
//        }
//        // 有效性验证  判断 Redis中存储的响应的用户是否过期
//        String userKey = JwtUtils.getUserKey(token);
//        if (!redisTemplate.hasKey(TokenConstants.LOGIN_TOKEN_KEY + userKey)) {
//            return GatewayUtils.errorResponse(exchange, "token过期");
//        } else {
//            // 续期
//            redisTemplate.expire(TokenConstants.LOGIN_TOKEN_KEY + userKey, 30, TimeUnit.MINUTES);
//        }
//        // 方形
//        return chain.filter(exchange);
//    }
//
//    /**
//     * 规定过滤器执行顺序方法  过滤器可以有多个   返回值越小 优先级越高
//     * @return
//     */
//    @Override
//    public int getOrder() {
//        return 0;
//    }
//
//}
