package com.bwie.mq.consumer;

import com.alibaba.fastjson.JSONObject;
import com.bwie.common.domain.User;
import com.google.gson.JsonObject;

import com.rabbitmq.client.Channel;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.annotation.Queue;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.mail.javamail.JavaMailSender;
import org.springframework.mail.javamail.MimeMessageHelper;
import org.springframework.stereotype.Component;

import javax.mail.MessagingException;
import javax.mail.internet.MimeMessage;
import java.io.IOException;

/**
 * @Author：weiran
 * @Package：com.bwie.mq.consumer
 * @Project：week3
 * @name：Pass
 * @Date：2024/8/6 13:53
 */
@Component
public class Pass {

    @Autowired
    private RabbitTemplate rabbitTemplate;
    @Autowired
    private StringRedisTemplate redisTemplate;
    @Autowired
    private JavaMailSender javaMailSender;

    @RabbitListener(queuesToDeclare = @Queue("sendemail"))
    public void sendemail(String users , Message message, Channel channel) throws RuntimeException, IOException {
        User user = JSONObject.parseObject(users, User.class);
        String messageId = message.getMessageProperties().getMessageId();
        Long userKey = redisTemplate.opsForSet().add("SENDEMAIL", messageId);
        if (userKey!=null && userKey==1){
            try {

                MimeMessage mimeMessage = javaMailSender.createMimeMessage();
                MimeMessageHelper helper = new MimeMessageHelper(mimeMessage, true);
                helper.setFrom("2392355487@qq.com");
                helper.setTo(user.getUserEmail());
                helper.setSubject("审核通知");
                helper.setText("尊敬的"+user.getUserName()+user.getEmailwhat());
                javaMailSender.send(mimeMessage);
                channel.basicAck(message.getMessageProperties().getDeliveryTag(), false);
            } catch (MessagingException e) {
                redisTemplate.opsForSet().remove("SENDEMAIL", messageId);
                channel.basicAck(message.getMessageProperties().getDeliveryTag(),true);
                throw new RuntimeException(e);
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }


    }
}
