package com.bwie.position.controller;

import com.bwie.common.domain.WaitPerson;
import com.bwie.common.domain.request.PositionReq;
import com.bwie.position.service.PositionService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.*;

import com.bwie.common.result.Result;

/**
 * @Author：weiran
 * @Package：com.bwie.position.controller
 * @Project：week3
 * @name：PositionController
 * @Date：2024/8/6 11:26
 */
@RestController
@RequestMapping("/position")
public class PositionController {
    @Autowired
    private PositionService positionService;


    /**
     * 查询企业招聘列表
     * @param positionReq
     * @return
     */
    @PostMapping("/findpositionList")
    public Result findlist(@RequestBody PositionReq positionReq){
       return Result.success(positionService.findlist(positionReq));
    }

    /**
     * 查询企业列表
     * @param
     * @return
     */
    @GetMapping("/findcompanyList")
    public Result findcompanylist(){
       return Result.success(positionService.findcompanylist());
    }


    /**
     * 查询最新岗位
     */
    @PostMapping("/latest")
    public Result findlatest(){
        return Result.success(positionService.findlatest());
    }

    /**
     * 投递简历
     */
    @PostMapping("/addwaitperson")
    public Result addwaitperson(@RequestBody WaitPerson waitPerson){
        Integer addwaitperson = positionService.addwaitperson(waitPerson);
        if (addwaitperson==2){
            return Result.error("该岗位您已投递过，请耐心等待");
        }

        if (addwaitperson>0){
            return Result.success(null, "操作成功");
        }

        return Result.error("操作失败");
    }

    /**
     * 候选人列表
     */
    @PostMapping("/findwaitpersonList")
    public Result findwaitpersonList(){
        return Result.success(positionService.findwaitpersonList());
    }

    /**
     * 通过
     */
    @PostMapping("/passyes")
    public Result passyes(@RequestBody WaitPerson waitPerson){
        Integer passyes = positionService.passyes(waitPerson);
        if(passyes>0){
            return Result.success(null,"操作成功");
        }
        return Result.error("操作失败");
    }


    /**
     * 不通过
     */
    @PostMapping("/passno")
    public Result passno(@RequestBody WaitPerson waitPerson){
        Integer passno = positionService.passno(waitPerson);
        if(passno>0){
            return Result.success(null,"操作成功");
        }
        return Result.error("操作失败");
    }

    /**
     * 查询是否失效
     */
//    @Scheduled(cron = "* * * 0/10 * *")
    @PostMapping("/expire")
    public void expire(){
        positionService.expire();
    }
}
