package com.bwie.user.controller;

import com.bwie.common.domain.response.UserResp;
import com.bwie.common.result.Result;
import com.bwie.user.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Author：weiran
 * @Package：com.bwie.user.controller
 * @Project：week3
 * @name：UserController
 * @Date：2024/8/6 10:19
 */
@RestController
@RequestMapping("/user")
public class UserController {
    @Autowired
    private UserService userService;


    /**
     * 判断手机号是否存在
     * @param userPhone
     * @return
     */
    @PostMapping("/user/findByuserPhone/{userPhone}")
    Result<UserResp> findByuserPhone(@PathVariable String userPhone){
        return Result.success(userService.findByuserPhone(userPhone));
    }
}
